/**
 * Created by Tony on 2018/6/12.
 */

let test = require('tape');
const JpcEx = require("../../../modules/reports/rpt_component/jpc_ex");
const JV = require("../../../modules/reports/rpt_component/jpc_value_define");
let config = require("../../../config/config.js");
config.setupDb(process.env.NODE_ENV);
let mongoose = require("mongoose");
let fileUtils = require("../../../modules/common/fileUtils");
let path = require('path');
let dbm = require("../../../config/db/db_manager");
let rpt_cfg = require('./rpt_cfg');
dbm.connect(process.env.NODE_ENV);

//统一引用models
fileUtils.getGlobbedFiles('../../../modules/all_models/*.js').forEach(function(modelPath) {
    require(path.resolve(modelPath));
});

//config.setupCache();
let cfgCacheUtil = require("../../../config/cacheCfg");
cfgCacheUtil.setupDftCache();

let fsUtil = require("../../../public/fsUtil");

let demoPrjId = - 1;
// let demoRptId = 279;
// let demoRptId = 275; //测试模板-流水式
// let demoRptId = 337; //19表
// let demoRptId = 361; //封1
// let demoRptId = 279; //表04
// let demoRptId = 448; //封3
// let demoRptId = 450; //09
// let demoRptId = 704; //05
// let demoRptId = 626; //06
// let demoRptId = 743; //09-1
// let demoRptId = 452; //04
// let demoRptId = 612; //09-3
// let demoRptId = 530; //封2
// let demoRptId = 386; //04
// let demoRptId = 389; //10
// let demoRptId = 280; //11-1 暂列金
// let demoRptId = 514; //12
// let demoRptId = 2260; //测试基本信息
// let demoRptId = 613; //09-4 2018
// let demoRptId = 726; //定制：清单子目表
// let demoRptId = 756; //江西 封1
// let demoRptId = 710; //qa 01
// let demoRptId = 931; //qa 内蒙古2017 【扉-1】招标工程量清单扉页
// let demoRptId = 957; //qa 内蒙古2017 12-4
// let demoRptId = 1006; //qa 重庆2018 A03
// let demoRptId = 1007; //qa 重庆2018 A01
// let demoRptId = 475; //计日工
// let demoRptId = 551; //表05
// let demoRptId = 1104; //内蒙2017 表09

let demoRptId = 1162;

let pagesize = "A4";

//288: 11-2表(新)
//279: 04

// let userId_Leng = "59cdf14a0034a1000ba52b97"; //小冷User Id 换成_id了 QQ号
let userId_Leng = "5acac1e885bf55000bd055ba"; //小冷User Id2
let userId_me = "5b6a60b1c4ba33000dd417c0"; //我的
// let userId_HaiZhu = "5b5a66c4a3c23e000dccdd77"; //海珠user id
// demoPrjId = 720; //QA: DW3
//demoPrjId = 1626; //QA:
// demoPrjId = 2260; //QA:
// demoPrjId = 5029; //
// demoPrjId = 5029; //项目名称过长
demoPrjId = 23964; //
// demoPrjId = 4107; //UAT:
//*/
let userId_Dft = userId_Leng;
// let userId_Dft = "5a025c4c15074d134c2b9689";
/*/
 let userId_Dft = "595328da1934dc327cad08eb";
 //*/

let rptTplFacade = require("../../../modules/reports/facade/rpt_template_facade");
let rptTplDataFacade = require("../../../modules/reports/facade/rpt_tpl_data_facade");

const rptDataExtractor = require("../../../modules/reports/util/rpt_construct_data_util");
const rpt_xl_util = require("../../../modules/reports/util/rpt_excel_util");
const rpt_pdf_util = require("../../../modules/reports/util/rpt_pdf_util");

let fs = require('fs');
//设置Date Format函数
// fs.readFile(__dirname.slice(0, __dirname.length - 18) + '/public/web/date_util.js', 'utf8', 'r', function (err, data) {
//     eval(data);
// });
//备注： 经过测试nodejs 8.9.3版本不支持eval的方式修改prototype，为兼容考虑，把方法调整到stringUtil文件里
require('../../../public/stringUtil').setupDateFormat();

test('测试 - 测试模板啦: ', function (t) {
    rptTplFacade.getRptTemplate(demoRptId).then(function(rptTpl) {
        let rptDataUtil = new rptDataExtractor();
        rptDataUtil.initialize(rptTpl._doc);

        // fsUtil.writeObjToFile(rptTpl._doc, "D:/GitHome/建筑造价支持文件/报表模板/重庆市2018建筑工程_【表-09-4】施工技术措施项目清单计价表_招投标1.js");
        // t.pass('pass : only save the template!');
        // t.end();
        // return;

        let filter = rptDataUtil.getDataRequestFilter();
        // filter.push("project_info");
        filter.push("contractor_list");
        // console.log(filter);
        //正常应该根据报表模板定义的数据类型来请求数据
        rptTplDataFacade.prepareProjectData(userId_Dft, demoPrjId, filter, function (err, msg, rawDataObj) {
            if (!err) {
                try {
                    let dt = new Date();
                    fsUtil.writeObjToFile(rawDataObj, "D:/GitHome/ConstructionCost/tmp/rptTplRawDataObject_" + dt.getTime() + "_测试模板.jsp");
                    let tplData = rptDataUtil.assembleData(rawDataObj);
                    fsUtil.writeObjToFile(rawDataObj, "D:/GitHome/ConstructionCost/tmp/rptTplRawDataAfterCacl_" + dt.getTime() + "测试模板.jsp");
                    // fsUtil.writeObjToFile(tplData, "D:/GitHome/ConstructionCost/tmp/rptTplAssembledData_测试模板.jsp");
                    //it's time to build the report!!!
                    let printCom = JpcEx.createNew();
                    rptTpl[JV.NODE_MAIN_INFO][JV.NODE_PAGE_INFO][JV.PROP_PAGE_SIZE] = pagesize;
                    let defProperties = rpt_cfg;
                    let dftOption = JV.PAGING_OPTION_NORMAL;
                    printCom.initialize(rptTpl);
                    printCom.analyzeData(rptTpl, tplData, defProperties, dftOption, JV.OUTPUT_TYPE_EXCEL);
                    let maxPages = printCom.totalPages;
                    let customizeCfg = {"fillZero": true};
                    let pageRst = printCom.outputAsSimpleJSONPageArray(rptTpl, tplData, 1, maxPages, defProperties, customizeCfg);
                    if (pageRst) {
                        // fsUtil.writeObjToFile(pageRst, "D:/Temp/testBuiltPageResult_测试模板.jsp");
                        // rpt_xl_util.exportExcel(pageRst, pagesize, "local_test_rpt_excel", true, null, null, function(uuidName){
                        //     console.log("excel uuid: " + uuidName);
                        // });
                        // rpt_pdf_util.export_pdf_file(pageRst, pagesize, 'local_test_rpt_pdf', function(uuidName){
                        //     console.log("pdf uuid: " + uuidName);
                        // });
                    } else {
                        console.log("oh! no pages were created!");
                    }
                } catch (ex) {
                    console.log(ex);
                    t.pass('pass with exception!');
                    t.end();
                }

                t.pass('pass succeeded!');
                t.end();
            } else {
                console.log(msg);
                t.pass('pass with error!');
                t.end();
            }
        })
    });
});

test('close the connection', function (t) {
    setTimeout(function () {
        mongoose.disconnect();
        t.pass('closing db connection');
        t.end();
    }, 1000);
    // mongoose.disconnect();
    // t.pass('closing db connection');
    // t.end();
});